#pragma once

#include "Arduino.h"
#include "ESP8266HTTPClient.h"
#include "base64.h"

class GmailNotifier {

    public:

        GmailNotifier();
        GmailNotifier(const char* username, const char* password);
        void setUsername(const char* username);
        void setPassword(const char* password);
        bool sync();
        int16_t getUnread();

    private:

        void base64Encode();

        const char* _url = "https://mail.google.com/mail/feed/atom";
        const char* _username;
        const char* _password;
        const char* _encodedLoginCredentials;
        bool        _base64Encoded = false;
        int16_t     _unread = -1;

        HTTPClient  _client;

};