#pragma once

#include "Arduino.h"
#include "ArduinoJson.h"


#define isSnow(c) (c > 4 && c < 11) || (c > 12 && c < 19) || (c == 35) || (c > 40 && c < 44) || c == 46 ? true : false
#define isRain(c) (c == 11 || c == 12 || c == 40 || c == 45 || c == 47) ? true : false
#define isStorm(c) (c < 5) || (c > 36 && c < 40) ? true : false
// #define

class Weather {

    public:

        Weather();

        void        parse(const char* response);
        bool        isPrecipitation(uint16_t c);
        bool        isPrecipitation();
        const char* getSunrise();
        const char* getSunset();
        uint16_t    getConditionCode();
        uint16_t    getTodayCode();
        uint16_t    getTomorrowCode();
        int8_t      getConditionTemp();
        int8_t      getTodayHigh();
        int8_t      getTodayLow();
        int8_t      getTomorrowHigh();
        int8_t      getTomorrowLow();

        static uint8_t getHours(const char* time);
        static uint8_t getMinutes(const char* time);
        static uint8_t getWeatherCondition(int8_t todayLow, int8_t todayHigh, int8_t tomorrowLow, int8_t tomorrowHigh);

        static const uint8_t MODE_WARMER   = 0x01;
        static const uint8_t MODE_COLDER   = 0x02;
        static const uint8_t MODE_NEUTRAL  = 0x03;

    private:

        String      _sunrise;
        String      _sunset;
        uint16_t    _conditionCode;
        uint16_t    _todayCode;
        uint16_t    _tomorrowCode;
        int8_t      _conditionTemp;
        int8_t      _todayHigh;
        int8_t      _todayLow;
        int8_t      _tomorrowHigh;
        int8_t      _tomorrowLow;

};
